require "util"
require "defines"
require "story"

function checksupplies(name, count)
  local has = game.player.getitemcount(name)
  if game.player.vehicle ~= nil then
    has = has + game.player.vehicle.getitemcount(name)
  end
  game.player.gui.left.objectives.table.add{type="label", caption=game.getlocaliseditemname(name)}
  if has < count then
    local label = game.player.gui.left.objectives.table.add{type="label", caption=has .. "/" .. count}
    label.style.fontcolor = {r = 1, g = 0.2, b = 0.2}
  else
    local label = game.player.gui.left.objectives.table.add{type="label", caption=count .. "/" .. count, style="caption_label_style"}
    label.style.fontcolor = {r = 0.3, g = 0.9, b = 0.3}
  end
  return  has >= count
end

game.oninit(function()
  game.player.force.disableallprototypes()
  game.mapsettings.enemy_expansion.enabled = false
  game.evolutionfactor = 0
  game.mapsettings.enemy_evolution.enabled = false

  local recipelist = game.player.force.recipes
  recipelist["iron-plate"].enabled = true
  recipelist["copper-plate"].enabled = true
  recipelist["stone-brick"].enabled = true
  recipelist["wood"].enabled = true
  recipelist["stone-furnace"].enabled = true
  recipelist["iron-stick"].enabled = true
  recipelist["iron-axe"].enabled = true
  recipelist["wooden-chest"].enabled = true
  recipelist["iron-gear-wheel"].enabled = true
  recipelist["burner-mining-drill"].enabled = true
  recipelist["basic-transport-belt"].enabled = true
  recipelist["burner-inserter"].enabled = true
  recipelist["pipe"].enabled = true
  recipelist["pipe-to-ground"].enabled = true
  recipelist["boiler"].enabled = true
  recipelist["steam-engine"].enabled = true
  recipelist["electronic-circuit"].enabled = true
  recipelist["copper-cable"].enabled = true
  recipelist["pistol"].enabled = true
  recipelist["basic-bullet-magazine"].enabled = true
  recipelist["offshore-pump"].enabled = true
  recipelist["small-electric-pole"].enabled = true
  recipelist["basic-mining-drill"].enabled = true
  recipelist["basic-inserter"].enabled = true
  recipelist["radar"].enabled = true
  recipelist["lab"].enabled = true
  recipelist["science-pack-1"].enabled = true
  recipelist["science-pack-2"].enabled = true
  recipelist["stone-wall"].enabled = true
  recipelist["repair-pack"].enabled = true
  
  local technologies = game.player.force.technologies
  technologies["automation"].researched = true
  technologies["logistics"].researched = true
  technologies["logistics-2"].enabled = true
  technologies["automobilism"].researched = true
  technologies["military"].researched = true
  technologies["military-2"].enabled = true
  technologies["optics"].researched = true
  technologies["steel-processing"].researched = true
  technologies["automation-2"].enabled = true
  technologies["turrets"].researched = true
  technologies["armor-making"].enabled = true
  technologies["armor-making-2"].enabled = true
  technologies["railway"].enabled = true
  technologies["automated-rail-transportation"].enabled = true
  technologies["electric-energy-distribution-1"].enabled = true
  technologies["bullet-damage-1"].researched = true
  technologies["bullet-damage-2"].enabled = true
  technologies["bullet-damage-3"].enabled = true
  technologies["bullet-speed-1"].researched = true
  technologies["bullet-speed-2"].enabled = true
  technologies["bullet-speed-3"].enabled = true
  technologies["advanced-material-processing"].enabled = true
  technologies["electronics"].enabled = true
  technologies["solar-energy"].enabled = true
  technologies["engine"].enabled = true
  technologies["rail-signals"].enabled = true
  technologies["advanced-electronics"].enabled = true
  technologies["inserter-stack-size-bonus-1"].enabled = true
  technologies["inserter-stack-size-bonus-2"].enabled = true
  
  local character = game.player.character
  character.insert{name = "iron-plate", count = 200}
  character.insert{name = "copper-plate", count = 100}
  character.insert{name = "coal", count = 20}
  character.insert{name = "basic-transport-belt", count = 50}
  character.insert{name = "basic-inserter", count = 10}
  character.insert{name = "small-electric-pole", count = 10}
  character.insert{name = "long-handed-inserter", count = 10}
  character.insert{name = "basic-mining-drill", count = 5}
  character.insert{name = "submachine-gun", count = 1}
  character.insert{name = "basic-bullet-magazine", count = 20}
  character.insert{name = "iron-axe", count = 1}
  character.insert{name = "electronic-circuit", count = 100}
  character.insert{name = "assembling-machine-1", count = 4}
  character.insert{name = "lab", count = 4}
  character.insert{name = "stone", count = 200}
  character.insert{name = "wood", count = 50}
  character.insert{name = "iron-gear-wheel", count = 50}
  character.insert{name = "pipe", count = 30}
end)

storytable =
{
  {
    {
      action =
      function()
        game.player.setgoaldescription("")
        game.showmessagedialog{text = {"msg-came-too-late"}}
        game.showmessagedialog{text = {"msg-everyone-dead"}}
        game.showmessagedialog{text = {"msg-biters-are-dangerous"}}
        game.showmessagedialog{text = {"msg-recover-base"}}
        game.showmessagedialog{text = {"msg-rails"}}
      end
    },
    {
      condition = story.Story:elapsedcheck(3),
      action =
      function()
        game.player.setgoaldescription({"goal-recover-base-and-research-railway"})
      end
    },
    {
      condition = function() return game.player.force.technologies["automated-rail-transportation"].researched end,
      action =
      function()
        game.player.setgoaldescription("")
        game.player.print({"think-recover-railway"})
      end
    },
    {
      condition = story.Story:elapsedcheck(6),
      action =
      function()
        game.player.setgoaldescription({"goal-get-supplies"})
        game.player.setgoaldescription("")
      end
    },
    {
      init =
      function()
        local objectives = game.player.gui.left.add{type="frame", name="objectives", caption = {"goal-title"}, direction = "vertical"}
        objectives.add{type="label", caption = {"goal-get-supplies"}}
        objectives.add{type="label", caption = {"car-contents-counting-logic"}}
        objectives.add{type="table", colspan=2, name="table"}
      end,
      condition =
      function()
        local result = true
        game.player.gui.left.objectives.table.destroy()
        game.player.gui.left.objectives.add{type="table", colspan=2, name="table"}
        result = checksupplies("piercing-bullet-magazine", 2500) and result
        result = checksupplies("steel-plate", 1500) and result
        result = checksupplies("iron-plate", 3000) and result
        result = checksupplies("copper-plate", 3000) and result
        result = checksupplies("solar-panel", 50) and result
        return result
      end,
      action =
      function()
        game.player.setgoaldescription("")
        game.showmessagedialog{text = {"msg-ready-to-go"}}
      end
    },
    {}
  }
}

mainstory = story.Story:new(storytable)

game.onsave(function()
  glob.storydata = mainstory:export()
end)

game.onload(function()
  mainstory:import(glob.storydata)
end)

game.onevent(defines.events, function(event)
  mainstory:update(event, "level-03")
end)

